<template>
  <Dialog :title="dialogTitle" v-model="dialogVisible">
    <el-form ref="formRef" :model="formData" :rules="formRules" v-loading="formLoading">
      <el-form-item label="邀请码" prop="code">
        <el-input v-model="formData.code" placeholder="请输入邀请码" />
      </el-form-item>
      <el-form-item label="邀请人用户ID" prop="ownerUserId">
        <el-input v-model="formData.ownerUserId" placeholder="请输入邀请人用户ID" />
      </el-form-item>
      <el-form-item label="状态" prop="status">
        <el-radio-group v-model="formData.status">
          <el-radio v-for="item in statusOptions" :key="item.value" :value="item.value">
            {{ item.label }}
          </el-radio>
        </el-radio-group>
      </el-form-item>
      <el-form-item label="创建时间" prop="createdAt">
        <el-date-picker v-model="formData.createdAt" type="date" value-format="x" placeholder="选择创建时间" />
      </el-form-item>
      <el-form-item label="过期时间" prop="expiresAt">
        <el-date-picker v-model="formData.expiresAt" type="date" value-format="x" placeholder="选择过期时间（留空永久有效）" />
      </el-form-item>
      <el-form-item label="最大可用次数" prop="maxUses">
        <el-input v-model="formData.maxUses" placeholder="请输入最大可用次数（留空不限）" />
      </el-form-item>
      <el-form-item label="已使用次数" prop="usedCount">
        <el-input v-model="formData.usedCount" placeholder="请输入已使用次数" />
      </el-form-item>
      <el-form-item label="系统用户ID" prop="systemUserId">
        <el-input v-model="formData.systemUserId" placeholder="请输入系统用户ID" />
      </el-form-item>
      <el-form-item label="邀请码所属租户" prop="ownerTenantId">
        <el-input v-model="formData.ownerTenantId" placeholder="请输入所属租户" />
      </el-form-item>
      <el-form-item label="邀请码所属系统用户" prop="owenrSystemUserId">
        <el-input v-model="formData.owenrSystemUserId" placeholder="请输入所属系统用户" />
      </el-form-item>
      <el-form-item label="邀请码类型" prop="inviteType">
        <el-select v-model="formData.inviteType" placeholder="请选择邀请码类型">
          <el-option v-for="item in inviteTypeOptions" :key="item.value" :label="item.label" :value="item.value" />
        </el-select>
      </el-form-item>
    </el-form>
    <template #footer>
      <el-button @click="submitForm" type="primary" :disabled="formLoading">确 定</el-button>
      <el-button @click="dialogVisible = false">取 消</el-button>
    </template>
  </Dialog>
</template>
<script setup lang="ts">
import { UserInviteCodesApi, UserInviteCodes } from '@/api/keyboard/userinvitecodes'

/** 用户生成的邀请码表，用于邀请新用户注册/安装并建立邀请关系 表单 */
defineOptions({ name: 'UserInviteCodesForm' })

const { t } = useI18n() // 国际化
const message = useMessage() // 消息弹窗

const dialogVisible = ref(false) // 弹窗的是否展示
const dialogTitle = ref('') // 弹窗的标题
const formLoading = ref(false) // 表单的加载中：1）修改时的数据加载；2）提交的按钮禁用
const formType = ref('') // 表单的类型：create - 新增；update - 修改
const formData = ref({
  id: undefined,
  code: undefined,
  ownerUserId: undefined,
  status: undefined,
  createdAt: undefined,
  expiresAt: undefined,
  maxUses: undefined,
  usedCount: undefined,
  systemUserId: undefined,
  ownerTenantId: undefined,
  owenrSystemUserId: undefined,
  inviteType: undefined
})
const formRules = reactive({
  code: [{ required: true, message: '邀请码不能为空', trigger: 'blur' }],
  ownerUserId: [{ required: true, message: '邀请人用户ID不能为空', trigger: 'blur' }],
  status: [{ required: true, message: '状态不能为空', trigger: 'change' }],
  createdAt: [{ required: true, message: '创建时间不能为空', trigger: 'blur' }],
  usedCount: [{ required: true, message: '已使用次数不能为空', trigger: 'blur' }],
  inviteType: [{ required: true, message: '邀请码类型不能为空', trigger: 'change' }]
})
const formRef = ref() // 表单 Ref
const statusOptions = [
  { label: '启用', value: 1 },
  { label: '停用', value: 0 }
]
const inviteTypeOptions = [
  { label: '用户', value: 'USER' },
  { label: '代理', value: 'AGENT' }
]

/** 打开弹窗 */
const open = async (type: string, id?: number) => {
  dialogVisible.value = true
  dialogTitle.value = t('action.' + type)
  formType.value = type
  resetForm()
  // 修改时，设置数据
  if (id) {
    formLoading.value = true
    try {
      formData.value = await UserInviteCodesApi.getUserInviteCodes(id)
    } finally {
      formLoading.value = false
    }
  }
}
defineExpose({ open }) // 提供 open 方法，用于打开弹窗

/** 提交表单 */
const emit = defineEmits(['success']) // 定义 success 事件，用于操作成功后的回调
const submitForm = async () => {
  // 校验表单
  await formRef.value.validate()
  // 提交请求
  formLoading.value = true
  try {
    const data = formData.value as unknown as UserInviteCodes
    if (formType.value === 'create') {
      await UserInviteCodesApi.createUserInviteCodes(data)
      message.success(t('common.createSuccess'))
    } else {
      await UserInviteCodesApi.updateUserInviteCodes(data)
      message.success(t('common.updateSuccess'))
    }
    dialogVisible.value = false
    // 发送操作成功的事件
    emit('success')
  } finally {
    formLoading.value = false
  }
}

/** 重置表单 */
const resetForm = () => {
  formData.value = {
    id: undefined,
    code: undefined,
    ownerUserId: undefined,
    status: undefined,
    createdAt: undefined,
    expiresAt: undefined,
    maxUses: undefined,
    usedCount: undefined,
    systemUserId: undefined,
    ownerTenantId: undefined,
    owenrSystemUserId: undefined,
    inviteType: undefined
  }
  formRef.value?.resetFields()
}
</script>
